#property copyright "hopfi2k@me.com"
#property link      ""

#property indicator_chart_window

extern bool AutoDetectPairs = TRUE;
extern bool ShowJumps = TRUE;
extern bool DisplayJumpInfo = TRUE;
extern bool ShowJumpAlert = FALSE;
extern bool ShowBasketBackground = TRUE;
extern string SetForSell = "-----[Custom SELL pairs]-----";
extern string CustomSell_1 = "NZDJPY";
extern string CustomSell_2 = "USDJPY";
extern string CustomSell_3 = "GBPCHF";
extern string CustomSell_4 = "CHFJPY";
extern string CustomSell_5 = "AUDUSD";
extern string CustomSell_6 = "EURCHF";
extern string CustomSell_7 = "EURUSD";
extern string SetForBuy = "-----[Custom BUY pairs]-----";
extern string CustomBuy_1 = "EURGBP";
extern string CustomBuy_2 = "GBPUSD";
extern string CustomBuy_3 = "USDCHF";
extern string CustomBuy_4 = "NZDUSD";
extern string CustomBuy_5 = "EURJPY";
extern string CustomBuy_6 = "AUDJPY";
extern string CustomBuy_7 = "GBPJPY";
extern string Comm1 = "Coordinates Placement on The Chart";
extern int MP_Y = 0;
extern int MP_X = 10;
int gi_240 = 55295;
int gi_unused_244 = 11788021;
int gi_248 = 255;
int gi_252 = 3329330;
int gi_256 = 13826810;
int gi_260 = 32768;
int gi_264 = 9498256;
int gi_268 = 255;
int gi_272 = 6053069;
int gi_276 = 9109504;
int gi_280;
double gd_284;
double gda_292[];
double gd_296 = 0.1;
string gs_304 = "";
string gs_unused_312 = "";
string gs_320 = "";
string gsa_328[14] = {""};
string gsa_332[2][14] = {"EURUSD", "USDJPY", "AUDUSD", "NZDJPY", "GBPCHF", "CHFJPY", "EURCHF", "GBPUSD", "EURGBP", "GBPJPY", "USDCHF", "NZDUSD", "AUDJPY", "EURJPY",
   "GBPUSD", "EURGBP", "GBPCHF", "CHFJPY", "AUDJPY", "EURJPY", "USDCHF", "CADJPY", "AUDUSD", "USDJPY", "EURUSD", "EURCHF", "GBPJPY", "USDCAD"};
string gs_336;
string gs_344;
int gi_352;
int gi_356;
int g_datetime_360 = 0;
int gi_364;
int gi_368 = 1;

int init() {
   gs_304 = SetTradingPairs(gsa_328, AutoDetectPairs);
   return (0);
}

int deinit() {
   Comment("");
   GlobalVariablesDeleteAll("Pj - Slot BTS");
   GlobalVariablesDeleteAll("VTM");
   ObjectsDeleteAll(EMPTY, OBJ_LABEL);
   return (0);
}

int start() {
   int li_unused_36;
   int li_unused_40;
   int li_60;
   int li_68;
   int li_72;
   int li_76;
   int li_80;
   int li_84;
   int li_88;
   int li_92;
   int li_96;
   int li_100;
   int li_104;
   int l_ind_counted_0 = IndicatorCounted();
   double ld_4 = 0;
   double ld_12 = 0;
   double ld_20 = 0;
   double ld_28 = 0;
   for (int l_pos_44 = 0; l_pos_44 <= OrdersTotal(); l_pos_44++) {
      if (OrderSelect(l_pos_44, SELECT_BY_POS) == TRUE) {
         if (OrderType() == OP_BUY) ld_12 += OrderProfit();
         if (OrderType() == OP_SELL) ld_4 += OrderProfit();
      }
   }
   ld_28 = sumSELL();
   if (ld_28 < 0.0) li_unused_40 = gi_248;
   else li_unused_40 = gi_252;
   ld_20 = sumBUY();
   if (ld_20 < 0.0) li_unused_36 = gi_248;
   else li_unused_40 = gi_252;
   Write("Title", gi_368, MP_X + 2, MP_Y + 10, "Virtual Trade Monitor", 14, "Arial black", gi_240);
   Write("Subline", gi_368, MP_X, MP_Y + 31, "Indicator version " + "v2.1" + " (using " + gs_304 + " pairs)", 8, "Arial", DarkKhaki);
   Write("Head", gi_368, MP_X + 10, MP_Y + 50, "No. B/S     Pairs            Profit", 10, "Verdana", Silver);
   int li_48 = 55;
   string l_dbl2str_52 = "";
   for (l_pos_44 = 1; l_pos_44 <= 14; l_pos_44++) {
      li_48 += 15;
      l_dbl2str_52 = DoubleToStr(l_pos_44, 0);
      if (TradeType(CheckPairRank(l_pos_44)) == "Sell") gi_280 = gi_248;
      else gi_280 = gi_252;
      Write(l_dbl2str_52, gi_368, MP_X + 180, MP_Y + li_48, l_dbl2str_52 + ":  ", 11, "Verdana", gi_280);
      Write(l_dbl2str_52 + "T", gi_368, MP_X + 155, MP_Y + li_48, TradeType(CheckPairRank(l_pos_44)), 11, "Verdana", gi_280);
      Write(l_dbl2str_52 + "O", gi_368, MP_X + 78, MP_Y + li_48, CheckPairRank(l_pos_44), 11, "Verdana", gi_280);
      Write(l_dbl2str_52 + "P", gi_368, MP_X + 1, MP_Y + li_48, DoubleToStr(CheckPairProfit(CheckPairRank(l_pos_44)), 2), 11, "Verdana", gi_280);
      if (ShowBasketBackground) {
         if (l_pos_44 <= 7) li_60 = 65636 - 10 * l_pos_44;
         else li_60 = (10 * l_pos_44 - 60) << 8;
         Write(l_dbl2str_52 + "b", gi_368, MP_X + 1, MP_Y + li_48 - 1, "ggggggggggggg", 12, "Webdings", li_60);
         ObjectSet(l_dbl2str_52 + "b", OBJPROP_BACK, TRUE);
      }
      if (l_pos_44 == 7) li_48 += 8;
   }
   Write("=1", gi_368, MP_X + 1, MP_Y + 57, "", 11, "Symbol", gi_256);
   Write("=2", gi_368, MP_X + 1, MP_Y + 170, "", 11, "Symbol", gi_256);
   Write("=3", gi_368, MP_X + 1, MP_Y + 282, "", 11, "Symbol", gi_256);
   Write("SBS", gi_368, MP_X + 1, MP_Y + 292, "Sum Buys         Sum Sells      Buy/Sell Diff.", 8, "Arial", gi_256);
   Write("Sum", gi_368, MP_X + 1, MP_Y + 300, DoubleToStr(sum(), 2), 13, "Arial Black", gi_256);
   Write("Buys", gi_368, MP_X + 78, MP_Y + 304, DoubleToStr(ld_20, 2), 13, "Arial", gi_252);
   Write("Sells", gi_368, MP_X + 155, MP_Y + 304, DoubleToStr(ld_28, 2), 13, "Arial", gi_248);
   if (ld_28 < 0.0 && ld_20 > 0.0) {
      gs_320 = "LONG (strong)";
      gi_364 = gi_260;
   } else {
      if (ld_28 > 0.0 && ld_20 > 0.0 && ld_20 > ld_28) {
         gs_320 = "LONG (weak)";
         gi_364 = gi_264;
      } else {
         if (ld_28 > 0.0 && ld_20 < 0.0) {
            gs_320 = "SHORT (strong)";
            gi_364 = gi_268;
         } else {
            if (ld_28 > 0.0 && ld_20 > 0.0 && ld_20 < ld_28) {
               gs_320 = "SHORT (weak)";
               gi_364 = gi_272;
            } else {
               gs_320 = "NO TREND";
               gi_364 = gi_276;
            }
         }
      }
   }
   int li_64 = 311;
   DetectLastJumpPairs(gsa_328);
   if (ShowJumps) {
      li_80 = 0;
      li_84 = 0;
      li_88 = 0;
      li_92 = 0;
      li_96 = 0;
      li_100 = 0;
      li_68 = gi_352;
      li_72 = gi_356;
      for (l_pos_44 = 0; l_pos_44 < 14; l_pos_44++) {
         ObjectDelete("VTM" + "JP" + l_pos_44);
         ObjectDelete("VTM" + "JPL" + l_pos_44);
      }
      li_76 = SlotDistance(li_68, li_72);
      if (li_68 > 7) li_80 = 8;
      if (li_72 > 7) li_84 = 8;
      li_88 = 0;
      if (li_76 != 0) {
         Write("VTM" + "JP1", gi_368, MP_X + 219, MP_Y + 54 + 15 * li_68 + li_80, "-", 11, "Symbol", White);
         Write("VTM" + "JP2", gi_368, MP_X + 213, MP_Y + 54 + 15 * li_72 + li_84, "", 11, "Symbol", White);
         if ((li_68 == 7 && li_72 == 8) || (li_72 == 7 && li_68 == 8)) Write("VTM" + "JP3", gi_368, MP_X + 220, MP_Y + 169, "", 16, "Symbol", White);
         else {
            if (li_68 < li_72) {
               li_92 = li_68;
               li_96 = li_72;
            } else {
               li_92 = li_72;
               li_96 = li_68;
            }
            if (li_92 > 7 && li_96 > 7) li_96--;
            li_100 = 0;
            for (l_pos_44 = li_92; l_pos_44 <= li_96; l_pos_44++) {
               li_88 = 15 * l_pos_44;
               if (li_92 > 7 && li_96 > 7) Write("VTM" + "JP5" + l_pos_44, gi_368, MP_X + 223, MP_Y + 72 + li_88, "", 11, "Symbol", White);
               else {
                  if (l_pos_44 == 7 && l_pos_44 != li_96) {
                     Write("VTM" + "JP4", gi_368, MP_X + 220, MP_Y + 169, "", 16, "Symbol", White);
                     l_pos_44++;
                     li_100 -= 8;
                  } else
                     if (l_pos_44 != 7) Write("VTM" + "JPL" + l_pos_44, gi_368, MP_X + 223, MP_Y + 64 + li_88 + li_100, "", 11, "Symbol", White);
               }
            }
         }
      }
   }
   if (DisplayJumpInfo) {
      li_104 = TimeCurrent() - g_datetime_360;
      Write("=4", gi_368, MP_X + 1, MP_Y + li_64, "", 11, "Symbol", gi_256);
      if (g_datetime_360 != 0) {
         Write("Jump1", gi_368, MP_X + 1, MP_Y + li_64 + 11, "Time since last jump: " + TimeToStr(li_104, TIME_SECONDS), 10, "Arial", Gold);
         Write("Jump2", gi_368, MP_X + 1, MP_Y + li_64 + 26, gs_336 + " jumped from Slot " + gi_352 + " to " + gi_356, 10, "Arial", Gold);
      } else {
         Write("Jump1", gi_368, MP_X + 6, MP_Y + li_64 + 11, "No pairs jumping occured until now!", 10, "Arial", Gold);
         Write("Jump2", gi_368, MP_X + 53, MP_Y + li_64 + 26, "Still waiting for next jump...", 10, "Arial", Gold);
      }
      li_64 += 40;
   }
   Write("TREND", gi_368, MP_X + 145, MP_Y + li_64, "Trend: ", 18, "Impact", Black);
   Write("TRENDdir", gi_368, MP_X, MP_Y + li_64, gs_320, 18, "Impact", gi_364);
   Write("TRENDbg1", gi_368, MP_X, MP_Y + li_64 + 2, "ggggggg", 18, "Webdings", White);
   Write("TRENDbg2", gi_368, MP_X + 164, MP_Y + li_64 + 2, "gg", 18, "Webdings", White);
   ObjectSet("TRENDbg1", OBJPROP_BACK, TRUE);
   ObjectSet("TRENDbg2", OBJPROP_BACK, TRUE);
   li_64 += 30;
   Write("Orders", gi_368, MP_X + 90, MP_Y + li_64, "Open orders", 10, "Impact", gi_256);
   Write("OrdersBuy", gi_368, MP_X + 90, MP_Y + li_64 + 15, "BUY: " + DoubleToStr(ld_12, 2), 10, "Verdana", gi_256);
   Write("OrdersSell", gi_368, MP_X + 90, MP_Y + li_64 + 25, "SELL: " + DoubleToStr(ld_4, 2), 10, "Verdana", gi_256);
   Write("OrdersTotal", gi_368, MP_X + 90, MP_Y + li_64 + 45, "Result: " + DoubleToStr(ld_12 + ld_4, 2), 10, "Verdana", gi_256);
   if (ShowJumpAlert) {
      RankChangeAlert(gsa_328[0], 1);
      RankChangeAlert(gsa_328[1], 2);
      RankChangeAlert(gsa_328[2], 3);
      RankChangeAlert(gsa_328[3], 4);
      RankChangeAlert(gsa_328[4], 5);
      RankChangeAlert(gsa_328[5], 6);
      RankChangeAlert(gsa_328[6], 7);
      RankChangeAlert(gsa_328[7], 8);
      RankChangeAlert(gsa_328[8], 9);
      RankChangeAlert(gsa_328[9], 10);
      RankChangeAlert(gsa_328[10], 11);
      RankChangeAlert(gsa_328[11], 12);
      RankChangeAlert(gsa_328[12], 13);
      RankChangeAlert(gsa_328[13], 14);
   }
   gda_292[0] = sum();
   return (0);
}

double OpenWeek(string a_symbol_0, int ai_8) {
   double l_iopen_12;
   if (ai_8 < 8) l_iopen_12 = iOpen(a_symbol_0, PERIOD_W1, 0);
   else l_iopen_12 = iOpen(a_symbol_0, PERIOD_W1, 0);
   return (l_iopen_12);
}

double ProfitPair(int ai_0) {
   double ld_12;
   string l_symbol_4 = gsa_328[ai_0 - 1];
   RefreshRates();
   double ld_20 = MarketInfo(l_symbol_4, MODE_TICKVALUE) / MarketInfo(l_symbol_4, MODE_TICKSIZE) * MarketInfo(l_symbol_4, MODE_POINT);
   double ld_28 = CalcSpread(l_symbol_4) * MarketInfo(l_symbol_4, MODE_POINT);
   if (ai_0 < 8) ld_12 = (OpenWeek(l_symbol_4, ai_0) - ld_28 - MarketInfo(l_symbol_4, MODE_ASK) - ld_28) / MarketInfo(l_symbol_4, MODE_POINT) * ld_20;
   else ld_12 = (MarketInfo(l_symbol_4, MODE_BID) + ld_28 - OpenWeek(l_symbol_4, ai_0)) / MarketInfo(l_symbol_4, MODE_POINT) * ld_20;
   return (NormalizeDouble(ld_12 * gd_296, 2));
}

string CheckPairRank(int ai_0) {
   if (ai_0 == Rank(1)) return (gsa_328[0]);
   if (ai_0 == Rank(2)) return (gsa_328[1]);
   if (ai_0 == Rank(3)) return (gsa_328[2]);
   if (ai_0 == Rank(4)) return (gsa_328[3]);
   if (ai_0 == Rank(5)) return (gsa_328[4]);
   if (ai_0 == Rank(6)) return (gsa_328[5]);
   if (ai_0 == Rank(7)) return (gsa_328[6]);
   if (ai_0 == Rank(8)) return (gsa_328[7]);
   if (ai_0 == Rank(9)) return (gsa_328[8]);
   if (ai_0 == Rank(10)) return (gsa_328[9]);
   if (ai_0 == Rank(11)) return (gsa_328[10]);
   if (ai_0 == Rank(12)) return (gsa_328[11]);
   if (ai_0 == Rank(13)) return (gsa_328[12]);
   if (ai_0 == Rank(14)) return (gsa_328[13]);
   return ("");
}

double CheckPairProfit(string as_0) {
   if (as_0 == gsa_328[0]) return (ProfitPair(1));
   if (as_0 == gsa_328[1]) return (ProfitPair(2));
   if (as_0 == gsa_328[2]) return (ProfitPair(3));
   if (as_0 == gsa_328[3]) return (ProfitPair(4));
   if (as_0 == gsa_328[4]) return (ProfitPair(5));
   if (as_0 == gsa_328[5]) return (ProfitPair(6));
   if (as_0 == gsa_328[6]) return (ProfitPair(7));
   if (as_0 == gsa_328[7]) return (ProfitPair(8));
   if (as_0 == gsa_328[8]) return (ProfitPair(9));
   if (as_0 == gsa_328[9]) return (ProfitPair(10));
   if (as_0 == gsa_328[10]) return (ProfitPair(11));
   if (as_0 == gsa_328[11]) return (ProfitPair(12));
   if (as_0 == gsa_328[12]) return (ProfitPair(13));
   if (as_0 == gsa_328[13]) return (ProfitPair(14));
   return (0.0);
}

double sum() {
   double ld_0 = 0;
   for (int li_8 = 1; li_8 < 15; li_8++) ld_0 += ProfitPair(li_8);
   gd_284 = ld_0;
   return (gd_284);
}

int Rank(int ai_0) {
   double lda_4[15];
   for (int li_8 = 14; li_8 > 0; li_8--) lda_4[li_8] = ProfitPair(li_8);
   ArraySort(lda_4, WHOLE_ARRAY, 0, MODE_ASCEND);
   int li_12 = ArrayBsearch(lda_4, ProfitPair(ai_0), WHOLE_ARRAY, 1);
   return (15 - li_12);
}

int GetPairRank(int ai_0) {
   double lda_4[15];
   for (int li_12 = 14; li_12 > 0; li_12--) lda_4[li_12] = ProfitPair(li_12);
   ArraySort(lda_4, WHOLE_ARRAY, 0, MODE_ASCEND);
   int li_8 = ArrayBsearch(lda_4, ProfitPair(ai_0 + 1), WHOLE_ARRAY, 1);
   return (15 - li_8);
}

string TradeType(string as_0) {
   if (as_0 == gsa_328[0]) return ("Sell");
   if (as_0 == gsa_328[1]) return ("Sell");
   if (as_0 == gsa_328[2]) return ("Sell");
   if (as_0 == gsa_328[3]) return ("Sell");
   if (as_0 == gsa_328[4]) return ("Sell");
   if (as_0 == gsa_328[5]) return ("Sell");
   if (as_0 == gsa_328[6]) return ("Sell");
   if (as_0 == gsa_328[7]) return ("Buy");
   if (as_0 == gsa_328[8]) return ("Buy");
   if (as_0 == gsa_328[9]) return ("Buy");
   if (as_0 == gsa_328[10]) return ("Buy");
   if (as_0 == gsa_328[11]) return ("Buy");
   if (as_0 == gsa_328[12]) return ("Buy");
   if (as_0 == gsa_328[13]) return ("Buy");
   return ("");
}

void RankChangeAlert(string as_0, int ai_8) {
   if (!GlobalVariableCheck(StringConcatenate("Pj - Slot BTS", as_0, ai_8))) GlobalVariableSet(StringConcatenate("Pj - Slot BTS", as_0, ai_8), Rank(ai_8));
   if (GlobalVariableGet(StringConcatenate("Pj - Slot BTS", as_0, ai_8)) <= 7.0) {
      if (Rank(ai_8) > 7) {
         Alert("Passed ", as_0, " with slots ", GlobalVariableGet(StringConcatenate("Pj - Slot BTS", as_0, ai_8)), " per slot ", Rank(ai_8), "");
         GlobalVariableSet(StringConcatenate("Pj - Slot BTS", as_0, ai_8), Rank(ai_8));
      }
   }
   if (GlobalVariableGet(StringConcatenate("Pj - Slot BTS", as_0, ai_8)) >= 8.0) {
      if (Rank(ai_8) < 8) {
         Alert("Passed ", as_0, " with slots ", GlobalVariableGet(StringConcatenate("Pj - Slot BTS", as_0, ai_8)), " per slot ", Rank(ai_8), "");
         GlobalVariableSet(StringConcatenate("Pj - Slot BTS", as_0, ai_8), Rank(ai_8));
      }
   }
   if (GlobalVariableGet(StringConcatenate("Pj - Slot BTS", as_0, ai_8)) != Rank(ai_8)) GlobalVariableSet(StringConcatenate("Pj - Slot BTS", as_0, ai_8), Rank(ai_8));
}

double CalcSpread(string a_symbol_0) {
   double ld_32;
   double l_spread_8 = MarketInfo(a_symbol_0, MODE_SPREAD);
   double l_digits_16 = MarketInfo(a_symbol_0, MODE_DIGITS);
   double l_point_24 = MarketInfo(a_symbol_0, MODE_POINT);
   if (l_digits_16 == 3.0 || l_digits_16 == 5.0) ld_32 = 10;
   else ld_32 = 1;
   l_spread_8 = NormalizeDouble(l_spread_8 / ld_32 * l_point_24, 0);
   return (l_spread_8);
}

void DetectLastJumpPairs(string asa_0[14]) {
   int li_24;
   string l_var_name_8 = "";
   string ls_16 = "";
   int li_28 = 0;
   for (int l_index_4 = 0; l_index_4 < 14; l_index_4++) {
      ls_16 = asa_0[l_index_4];
      l_var_name_8 = "VTM" + ls_16;
      if (!GlobalVariableCheck(l_var_name_8)) GlobalVariableSet(l_var_name_8, GetPairRank(l_index_4));
      else {
         li_28 = GetPairRank(l_index_4);
         li_24 = GlobalVariableGet(l_var_name_8);
         if (li_24 > 7 && li_28 < 8) {
            g_datetime_360 = TimeCurrent();
            gi_352 = li_24;
            gi_356 = li_28;
            gs_336 = ls_16;
            gs_344 = CheckPairRank(li_24);
            GlobalVariableSet(l_var_name_8, li_28);
         } else {
            if (li_24 <= 7 && li_28 > 7) {
               g_datetime_360 = TimeCurrent();
               gi_352 = li_24;
               gi_356 = li_28;
               gs_336 = ls_16;
               gs_344 = CheckPairRank(li_24);
               GlobalVariableSet(l_var_name_8, li_28);
            } else
               if (li_24 != li_28) GlobalVariableSet(l_var_name_8, li_28);
         }
      }
   }
}

void Write(string a_name_0, double a_corner_8, int a_x_16, int a_y_20, string a_text_24, int a_fontsize_32, string a_fontname_36, color a_color_44 = -1) {
   if (ObjectFind(a_name_0) == -1) ObjectCreate(a_name_0, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(a_name_0, a_text_24, a_fontsize_32, a_fontname_36, a_color_44);
   ObjectSet(a_name_0, OBJPROP_CORNER, a_corner_8);
   ObjectSet(a_name_0, OBJPROP_XDISTANCE, a_x_16);
   ObjectSet(a_name_0, OBJPROP_YDISTANCE, a_y_20);
}

double sumSELL() {
   double ld_0 = 0;
   for (int li_8 = 1; li_8 < 8; li_8++) ld_0 += ProfitPair(li_8);
   gd_284 = ld_0;
   return (gd_284);
}

double sumBUY() {
   double ld_0 = 0;
   for (int li_8 = 8; li_8 < 15; li_8++) ld_0 += ProfitPair(li_8);
   gd_284 = ld_0;
   return (gd_284);
}

string SetTradingPairs(string &asa_0[14], bool ai_4) {
   int li_8 = 1;
   string ls_ret_12 = "ORIGINAL";
   string ls_20 = "";
   string ls_28 = Symbol();
   if (StringLen(ls_28) > 6) {
      ls_20 = StringSubstr(ls_28, 6, StringLen(ls_28) - 6);
      Print("Detected non-standard Broker (adding suffix: " + ls_20 + ")");
   }
   if (ai_4) {
      for (int l_index_36 = 0; l_index_36 < 14; l_index_36++) {
         if (!MarketInfo(gsa_332[1][l_index_36] + ls_20, MODE_TRADEALLOWED)) {
            li_8 = 0;
            ls_ret_12 = "ALTERNATIVE";
         }
      }
      for (l_index_36 = 0; l_index_36 < 14; l_index_36++) asa_0[l_index_36] = gsa_332[li_8][l_index_36] + ls_20;
   } else {
      asa_0[0] = CustomSell_1;
      asa_0[1] = CustomSell_2;
      asa_0[2] = CustomSell_3;
      asa_0[3] = CustomSell_4;
      asa_0[4] = CustomSell_5;
      asa_0[5] = CustomSell_6;
      asa_0[6] = CustomSell_7;
      asa_0[7] = CustomBuy_1;
      asa_0[8] = CustomBuy_2;
      asa_0[9] = CustomBuy_3;
      asa_0[10] = CustomBuy_4;
      asa_0[11] = CustomBuy_5;
      asa_0[12] = CustomBuy_6;
      asa_0[13] = CustomBuy_7;
      ls_ret_12 = "CUSTOM";
   }
   return (ls_ret_12);
}

int SlotDistance(int ai_0, int ai_4) {
   if (ai_4 > ai_0) return (ai_4 - ai_0);
   return (ai_0 - ai_4);
}
